// file: $isip/class/stat/NGramModel/ngrm_01.cc
// version: $Id: ngrm_01.cc 8246 2002-06-27 16:36:58Z zheng $
//

// isip include files
//
#include "NGramModel.h"
#include "Console.h"

// method: debug
//
// arguments:
//  const unichar* msg: (input) message to print
//
// return: a boolean value indicating status
//
boolean NGramModel::debug(const unichar* msg_a) const {

  // declare local variables
  //  
  String value;
  String output;
  String empty_str;

  // output the information message
  //
  output.debugStr(name(), msg_a, L":");
  Console::put(output);

  // increase the indentation
  //  
  Console::increaseIndention();

  // display the ngram order
  //
  value.assign(order_d);
  output.debugStr(name(), empty_str, L"order_d", value);
  Console::put(output);

  // display the hash table
  //
  output.debugStr(name(), msg_a, L"gram_hash_d = ");
  Console::put(output);
  gram_hash_d.debug(L"gram hashtable");

  // decrease indention
  //
  Console::decreaseIndention();
  
  // exit gracefully
  //
  return true;
}
